import tkinter
from kreslenie import *
from ovladanie import *

class Intervalac():

    class Node():
        def __init__(self, zac=None, kon=None, data=None, left=None, right=None):
            self.data = data
            self.left = left
            self.right = right
            self.zac = zac
            self.kon = kon
            self.lazy = 0
            self.x = None
            self.y = None
            self.a = None
            self.vyraz = None
            self.stvorec = []
            self.text = []

    def __init__(self, prvky):
        self.len = len(prvky)
        self.root = self.Node(0, self.mocnina(len(prvky)))
        self.prvky = prvky
        self.neutral = 0 # neutrálna hodnota pre danú operáciu
        self.poc_prvkov = len(prvky)
        self.konstrukcia(self.root)

        self.color_bg = '#c2dcb7'
        self.color_lazy_syn = "#38b29a"
        self.color_sucet = "#B23850"
        self.color_vysledok_sucet = "#3B8BEB"
        self.color_panel = "#f6d198"
        self.color_zmena = "#862a5c"
        self.color_lazy = "orange"
        self.color_unused = "#8e8e90"

        try:
            with open("delay.txt", "r") as r:
                self.delay = int(r.readline().strip())
        except: self.delay = 700
        self.suma = None # vypísanie súčtu pri krokovaní
        self.canvas = tkinter.Canvas(width=1400, height=600, bg=self.color_bg) # triedny canvas
        self.canvas.pack()
        self.o = Ovladanie(self.canvas, self) # prepojenie s ovládacím panelom


    def mocnina(self, dlzka):
        m = 1
        while m < dlzka:
            m *= 2
        return m

    def konstrukcia(self, vrchol):
        # ano, je to rekurzívne, lebo hĺbka stromu nebude nikdy 1000, lebo 2**1000 je priveľa vrcholov
        if vrchol.kon - vrchol.zac == 1:
            if vrchol.zac < self.poc_prvkov:
                vrchol.data = self.prvky[vrchol.zac]
            else:
                vrchol.data = self.neutral
            return
        # vytváranie synov
        stred = (vrchol.kon+vrchol.zac)//2
        vrchol.left = self.Node(vrchol.zac, stred)
        vrchol.right = self.Node(stred, vrchol.kon)
        # konštruovanie synov
        self.konstrukcia(vrchol.left)
        self.konstrukcia(vrchol.right)
        # ked sa vynorím, moji synovia už majú data, updatnem svoje data
        vrchol.data = vrchol.left.data + vrchol.right.data

    def zmena(self, vrchol, index, hodnota):
        if vrchol.kon - vrchol.zac == 1:
            # som v liste
            if vrchol.zac == index:
                # v správnom liste
                urob_vyraz(self, vrchol) # grafické zvýraznenie
                vrchol.data = hodnota
                kresli_vrchol(self, vrchol) # grafické odzvýraznenie
            return

        if vrchol.zac <= index < vrchol.kon:
            if vrchol.lazy != 0:
                urob_vyraz(self, vrchol, self.color_lazy_syn)
                self.nebud_lazy(vrchol.left, vrchol.lazy)
                self.nebud_lazy(vrchol.right, vrchol.lazy)
                vrchol.lazy = 0
                kresli_vrchol(self, vrchol)
            urob_vyraz(self, vrchol) # grafické zvýraznenie
            # zmena v mojom  podstrome = delegujem
            self.zmena(vrchol.left, index, hodnota)
            self.zmena(vrchol.right, index, hodnota)
            # zmenili sa mi deti(možno), treba ma updatnúť
            vrchol.data = vrchol.left.data + vrchol.right.data
            kresli_vrchol(self, vrchol) # grafické odzvýraznenie
            return

        else: # zmena mimo mňa
            return

    def sucet(self, vrchol, z, k):
        sucet = 0
        if vrchol.zac >= k or vrchol.kon <= z:
            # to čo hladám je mimo mna
            return self.neutral
        if vrchol.zac >= z and vrchol.kon <= k:
            urob_vyraz(self, vrchol, self.color_vysledok_sucet) # grafické zvýraznenie
            # to čo obsahujem je celé súčasťou toho, čo sa hladá
            return vrchol.data
        # delegujem sa na deti, treba mna zbavit lazy a deti delegovat
        if vrchol.lazy != 0:
            urob_vyraz(self, vrchol, self.color_lazy_syn)
            self.nebud_lazy(vrchol.left, vrchol.lazy)
            self.nebud_lazy(vrchol.right, vrchol.lazy)
            vrchol.lazy = 0
            kresli_vrchol(self, vrchol)
        
        urob_vyraz(self, vrchol, self.color_sucet) # grafické zvýraznenie

        sucet += self.sucet(vrchol.left, z, k)
        sucet += self.sucet(vrchol.right, z, k)
        
        if self.suma is not None: self.canvas.delete(self.suma)
        self.suma = self.canvas.create_text(100, 20, text = "aktuálny súčet: "+str(sucet))
        kresli_vrchol(self, vrchol)
        return sucet

    def lazy_zmena(self, vrchol, z, k, hodnota):
        if vrchol.zac >= k or vrchol.kon <= z:
            # to čo hladám je mimo mna
            return
        if vrchol.zac >= z and vrchol.kon <= k:
            urob_vyraz(self, vrchol, self.color_lazy)
            # to čo obsahujem je celé súčasťou toho, čo sa hladá
            poc_podomnou = vrchol.kon - vrchol.zac
            vrchol.data += (hodnota * poc_podomnou)
            if vrchol.kon - vrchol.zac != 1: # nie som v liste
                vrchol.lazy += hodnota
            kresli_vrchol(self, vrchol)
            return
        # delegujem sa na deti, ked sa vrátim, updatnem sa
        if vrchol.lazy != 0:
            urob_vyraz(self, vrchol, self.color_lazy_syn)
            self.nebud_lazy(vrchol.left, vrchol.lazy)
            self.nebud_lazy(vrchol.right, vrchol.lazy)
            vrchol.lazy = 0
            kresli_vrchol(self, vrchol)
        urob_vyraz(self,vrchol, self.color_lazy)
        self.lazy_zmena(vrchol.left, z, k, hodnota)
        self.lazy_zmena(vrchol.right, z, k, hodnota)
        vrchol.data = vrchol.left.data + vrchol.right.data
        kresli_vrchol(self, vrchol)
        

    def nebud_lazy(self, vrchol, lazy):
        urob_vyraz(self, vrchol, self.color_lazy_syn)
        poc_podomnou = vrchol.kon - vrchol.zac
        vrchol.data += (lazy * poc_podomnou)
        if vrchol.kon - vrchol.zac != 1: # nie som v liste
            vrchol.lazy += lazy
        kresli_vrchol(self, vrchol)

    def uprac(self, vrch = None):
        if vrch is None: vrch = self.root
        if vrch == self.root: self.canvas.delete(self.suma)
        if vrch is None: return
        self.canvas.itemconfig(vrch.vyraz, outline="black", width=1)
        uprac_vyrazy(self, vrch.left)
        uprac_vyrazy(self, vrch.right)


def spusti():
    prvky = []
    with open("input.txt", "r") as r:
        for line in r:
            try:
                int(line.strip())
                if int(line.strip()) < 100:
                    prvky.append(int(line.strip()))
            except: pass
    with open("output.txt", "w") as w:
        w.write("Spustené queries a výsledky\n")
        w.write("počiatočný stav:\n" + " ".join(map(str, prvky)) + "\n\nVykonané queries:\n")
    strom = Intervalac(prvky)
    x = strom.delay
    strom.delay = 20
    kresli(strom, 450, 500, 50, strom.root, strom.len)
    strom.delay = x
    strom.canvas.mainloop()

spusti()